
###################################################################
# class StructuredPushConsumer
###################################################################
class StructuredPushConsumer
{
 # Constructor
 proc __StructuredPushConsumer__(self,name)
 {
   self.name = name;
   CORBA.ORB.connect(self,CosNotifyComm.StructuredPushConsumer);
 }
 # Implementation CosNotifyComm::NotifyPublish
  proc offer_change(self,added,removed)
  {
    println("PushConsumer(", self.name,") offer change: ");
    println("  added:",added);
    println("  removed:",removed);
  }
 # Implementation of the CosNotifyComm::SequencePushConsumer interface.
  proc push_structured_event(self,data)
  {
    println("PushConsumer(", self.name, ") receives ", data)
  }

  proc disconnect_sequence_push_consumer(self)
  {
    println("PushConsumer(", self.name, ") disconnect_push_consumer")
  }

	
 #Interface zum Programm
 proc connect(self,ncior)
 {
   idH = Holder();
   self.sa = ncior.new_for_consumers(CosNotifyChannelAdmin.InterFilterGroupOperator.AND_OP,idH);
   proxyidH = Holder();
   self.proxy = self.sa.obtain_notification_push_supplier(CosNotifyChannelAdmin.ClientType.STRUCTURED_EVENT,proxyidH);
   self.proxy.connect_structured_push_consumer(self);
   println("PushConsumer(", self.name, ") is connected to the NotifyChannel.")
 }

 proc subscribe(self,added)
 {
   remove=CosNotification.EventTypeSeq();
   self.proxy.subscription_change(added,remove);
 }
};




